<template>
	<div>
		<NavbarTop></NavbarTop>
		<h2>Calculator</h2>
		<div id="calculator">
			<div id="result">
				{{ displayValue }}
			</div>
			<div id="panel">
				<div class="btn" id="clear" @click="clear">C</div>
				<div class="btn" @click="handleOperator('/')">/</div>
				<div class="btn" @click="handleDigit(7)">7</div>
				<div class="btn" @click="handleDigit(8)">8</div>
				<div class="btn" @click="handleDigit(9)">9</div>
				<div class="btn" @click="handleOperator('x')">x</div>
				<div class="btn" @click="handleDigit(4)">4</div>
				<div class="btn" @click="handleDigit(5)">5</div>
				<div class="btn" @click="handleDigit(6)">6</div>
				<div class="btn" @click="handleOperator('-')">-</div>
				<div class="btn" @click="handleDigit(1)">1</div>
				<div class="btn" @click="handleDigit(2)">2</div>
				<div class="btn" @click="handleDigit(3)">3</div>
				<div class="btn" @click="handleOperator('+')">+</div>
				<div id="zero" class="btn" @click="handleDigit(0)">0</div>
				<div id="equal" class="btn" @click="handleOperator('=')">=</div>
			</div>
		</div>
	</div>
</template>

<script>
	import NavbarTop from '@/components/NavbarTop'
	export default {
		name: 'Calculator',
		components: {
			NavbarTop
		},
		data () {
			return {
				currentValue: 0,
				savedValue: false,
				currentOperator: false
			}
		},
		methods: {
			clear () {
				this.currentValue = 0,
				this.savedValue = false,
				this.currentOperator = false
			},
			handleDigit (digit) {
				if (this.currentOperator === '=') {
					this.savedValue = false
				}
				this.currentValue = this.currentValue * 10 + digit
			},
			handleOperator (operator) {
				if (this.currentOperator) {
					this.calculate()
				} else {
					this.savedValue = this.currentValue
				}
				this.currentValue = 0
				this.currentOperator = operator
			},
			calculate () {
				if (this.currentOperator === '+') {
					this.savedValue += this.currentValue
				} else if (this.currentOperator === '-') {
					this.savedValue -= this.currentValue
				} else if (this.currentOperator === 'x') {
					this.savedValue *= this.currentValue
				} else if (this.currentOperator === '/') {
					this.savedValue /= this.currentValue
				} else if (this.currentOperator === '=' && this.currentValue) {
					this.savedValue = this.currentValue
				}
				this.currentValue = 0
				this.currentOperator = false
			}
		},
		computed: {
			displayValue () {
				return this.savedValue ? this.currentValue ? this.currentValue : this.savedValue : this.currentValue
			}
		}
	}
</script>

<style scoped>
html {
	background: #CCC;
	font-family: sans-serif;
}
body {
	display: grid;
	justify-items: center;
	align-items: center;
	height: 100vh;
}
#calculator {
	border: 2px solid #222;
	border-radius: 4px;
	max-width: 350px;
	margin: auto;
}
#result {
	font-size: 42px;
	width: 100%;
	height: 70px;
	box-sizing: border-box;
	display: grid;
	padding: 10px;
	justify-items: end;
	align-items: center;
	border-bottom: 2px solid #222;
}
#panel {
	display: grid;
	grid-template-columns: repeat(4, minmax(60px, 1fr));
	grid-gap: 10px;
	padding: 15px;
}
.btn {
	cursor: pointer;
	font-size: 20px;
	display: grid;
	padding: 15px 10px;
	justify-items: center;
	align-items: center;
	color: #FAFAFA;
	border: 1px solid #222;
	border-radius: 4px;
	background: #777;
}
#clear {
	background: steelblue;
	grid-column: 1/4;
}
#zero {
	grid-column: 1/4;
}
#equal {
	background: seagreen;
}
</style>
